/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.ntb.usb.testApp;

/**
 *
 * @author rt
 */

public class TestDeviceResponse {

    private int replyType;
    protected byte[] responseData;
    private byte[] responsePayload;

    public enum replyCode {
        KB_UNKNOWN,
        KB_MODE,
        KB_SER_NO,
        KB_VER_NO,
        KB_NAK,
        KB_ACK
    }

    public TestDeviceResponse(){
        replyType = -1;
        responseData = new byte[64];
        responsePayload = new byte[64];
    }

    public void setReply(int reply){
        replyType = reply;
    }

    public int getReply(){
        return(replyType);
    }

    public int parseResponseData(){

        int dataLength = responseData.length;
        int loop = 0;
        int blockIndex = 0;
        int payloadLoop = 0;
        int success = 0;

        while(loop < dataLength ){
            blockIndex = loop % 4;
            switch(blockIndex){
                case 0:  // First element of a four part block

                    switch(responseData[loop]){
                        case 0x04:
                            // Do nothing as all remaining data is valid
                            break;
                        case 0x05:
                            // Message payload ends on next byte
                            dataLength = loop + 2;
                            break;
                        case 0x06:
                            // Message payload ends after next two bytes
                            dataLength = loop + 3;
                            break;
                        case 0x07:
                            // Message payload ends after next three bytes
                            dataLength = loop + 4;
                            break;
                        default:
                            // This is an error data not in 4 byte blocks
                            success = 1;
                            break;
                    }
                    break;
                case 1:  // Remaining elements of a data block
                case 2:
                case 3:  responsePayload[payloadLoop++] = responseData[loop];
                    break;
                default:
                         // This would be an error.
                    break;
            }
            loop++;
        }

        return(success);
    }


    public byte[] getResponsePayload(){
        return(responsePayload);
    }

}
