/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * uploaderUI.java
 *
 * Created on 28-Sep-2009, 17:12:03
 */

package ch.ntb.usb.uploader;

import ch.ntb.usb.LibusbJava;
import ch.ntb.usb.Usb_Bus;
import ch.ntb.usb.Usb_Device;
import ch.ntb.usb.Usb_Interface;
import ch.ntb.usb.Usb_Endpoint_Descriptor;
import ch.ntb.usb.Usb_Interface_Descriptor;
import ch.ntb.usb.Usb_Config_Descriptor;
import ch.ntb.usb.testApp.TestDevice;
import ch.ntb.usb.testApp.TestDeviceResponse;
import ch.ntb.usb.testApp.AbstractDeviceInfo.TransferMode;
import java.io.*;
import javax.swing.*;

import java.awt.*;
import java.beans.*;




/**
 *
 * @author rt
 */
public class uploaderUI extends javax.swing.JFrame
                            implements PropertyChangeListener {

    Usb_Device[] foundDevices = new Usb_Device[10];
    TestDevice testDevice;
    int selectedDevice = 0;
    byte[] uploadFile = null;
    byte[] uploadBinary = null;
    UploadTask uploadTask;

    // Note this version number is the version of the uploader tool itself.
    String version = "1.0.0";

    // This version number is the version of the keyboard firmware to which the
    // target will be updated.
    //   Customer Ver     Internal CME Version No
    //      1.0.0                   0.19
    //      1.1.0                   0.22
    //      1.1.1                   0.23

    String codeVersion = "1.10";
    public static final boolean DEBUG = false;

    /** Creates new form uploaderUI */
    public uploaderUI() {
        initComponents();
        this.setIconImage( new javax.swing.ImageIcon( ( this.getClass().getResource( "resources/AXiS logo small.gif" ) ) ,"Icon" ).getImage());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        messageDialogBox = new javax.swing.JOptionPane();
        aboutDialogBox = new javax.swing.JOptionPane();
        uploaderPanel = new javax.swing.JPanel();
        deviceComboBox = new javax.swing.JComboBox();
        selectKeyboardLabel = new javax.swing.JLabel();
        uploadButton = new javax.swing.JButton();
        uploadProgressBar = new javax.swing.JProgressBar();
        progressLabel = new javax.swing.JLabel();
        exitButton = new javax.swing.JButton();
        iconLabel = new javax.swing.JLabel();
        mainMenuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        exitMenuItem = new javax.swing.JMenuItem();
        viewMenu = new javax.swing.JMenu();
        refreshMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();

        aboutDialogBox.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ch/ntb/usb/uploader/resources/AXiS logo small.gif"))); // NOI18N

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("C-Thru Music Ltd");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        uploaderPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "AXiS-49 Update to version "+codeVersion, javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.TOP));

        deviceComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "None" }));
        deviceComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                deviceComboBoxItemStateChanged(evt);
            }
        });
        deviceComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deviceComboBoxActionPerformed(evt);
            }
        });

        selectKeyboardLabel.setText("Choose Keyboard");

        uploadButton.setText("Update Keyboard");
        uploadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uploadButtonActionPerformed(evt);
            }
        });

        progressLabel.setText(" ");
        progressLabel.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        javax.swing.GroupLayout uploaderPanelLayout = new javax.swing.GroupLayout(uploaderPanel);
        uploaderPanel.setLayout(uploaderPanelLayout);
        uploaderPanelLayout.setHorizontalGroup(
            uploaderPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(uploaderPanelLayout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(uploaderPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(uploadProgressBar, javax.swing.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                    .addComponent(uploadButton, javax.swing.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                    .addComponent(deviceComboBox, 0, 145, Short.MAX_VALUE))
                .addContainerGap(36, Short.MAX_VALUE))
            .addGroup(uploaderPanelLayout.createSequentialGroup()
                .addGap(61, 61, 61)
                .addGroup(uploaderPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(progressLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(selectKeyboardLabel))
                .addContainerGap(36, Short.MAX_VALUE))
        );
        uploaderPanelLayout.setVerticalGroup(
            uploaderPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(uploaderPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(selectKeyboardLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(deviceComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(uploadButton, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(progressLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(uploadProgressBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        exitButton.setText("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        iconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/ch/ntb/usb/uploader/resources/AXiS logo small.gif"))); // NOI18N
        iconLabel.setText("jLabel1");

        fileMenu.setMnemonic('F');
        fileMenu.setText("File");

        exitMenuItem.setMnemonic('x');
        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        mainMenuBar.add(fileMenu);

        viewMenu.setMnemonic('V');
        viewMenu.setText("View");

        refreshMenuItem.setMnemonic('R');
        refreshMenuItem.setText("Refresh");
        refreshMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refreshMenuItemActionPerformed(evt);
            }
        });
        viewMenu.add(refreshMenuItem);

        mainMenuBar.add(viewMenu);

        helpMenu.setMnemonic('H');
        helpMenu.setText("Help");

        aboutMenuItem.setMnemonic('A');
        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        mainMenuBar.add(helpMenu);

        setJMenuBar(mainMenuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(uploaderPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(exitButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 130, Short.MAX_VALUE)
                        .addComponent(iconLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(uploaderPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(iconLabel)
                    .addComponent(exitButton))
                .addContainerGap(11, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents


    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        testDevice.closeUsbDevice();
        System.exit(0);
}//GEN-LAST:event_exitButtonActionPerformed

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        testDevice.closeUsbDevice();
        System.exit(0);
}//GEN-LAST:event_exitMenuItemActionPerformed

    private void deviceComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deviceComboBoxActionPerformed
        /** Needs to change the Test device component to point to
         *  the new selection.
         */
        if(deviceComboBox.getItemCount() > 1){
            setTestDevice(deviceComboBox.getSelectedIndex());
        }
}//GEN-LAST:event_deviceComboBoxActionPerformed

    private void refreshMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refreshMenuItemActionPerformed
        this.scanForKeyboards();
}//GEN-LAST:event_refreshMenuItemActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        this.scanForKeyboards();
    }//GEN-LAST:event_formWindowOpened

    private void deviceComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_deviceComboBoxItemStateChanged
        // Combo box selection has changed close any devices and open newly selected ones
    }//GEN-LAST:event_deviceComboBoxItemStateChanged

    private void uploadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uploadButtonActionPerformed
        programTarget();
    }//GEN-LAST:event_uploadButtonActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        aboutDialogBox.showMessageDialog(this,
                                        "C-Thru Music Limited\nFirmware uploader " + version + "\nwww.c-thru-music.com",
                                        "About",
                                        -1,
                                        new javax.swing.ImageIcon(this.getClass().getResource("resources/AXiS logo small.gif")));
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new uploaderUI().setVisible(true);
            }
        });
    }

   /**
     * Invoked when task's progress property changes.
     */
    public void propertyChange(PropertyChangeEvent evt) {
        if ("progress" == evt.getPropertyName()) {
            int progress = (Integer) evt.getNewValue();
            uploadProgressBar.setValue(progress);
           //taskOutput.append(String.format(
            //        "Completed %d%% of task.\n", task.getProgress()));
        }
    }



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JOptionPane aboutDialogBox;
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JComboBox deviceComboBox;
    private javax.swing.JButton exitButton;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JLabel iconLabel;
    private javax.swing.JMenuBar mainMenuBar;
    private javax.swing.JOptionPane messageDialogBox;
    private javax.swing.JLabel progressLabel;
    private javax.swing.JMenuItem refreshMenuItem;
    private javax.swing.JLabel selectKeyboardLabel;
    private javax.swing.JButton uploadButton;
    private javax.swing.JProgressBar uploadProgressBar;
    private javax.swing.JPanel uploaderPanel;
    private javax.swing.JMenu viewMenu;
    // End of variables declaration//GEN-END:variables

    
    class UploadTask extends SwingWorker <Void, Void> {
        /*
         * Main task. Executed in background thread.
         */

        @Override
        public Void doInBackground() {

            // Erase part
            TestDeviceResponse response = new TestDeviceResponse();
            progressLabel.setText("Erasing keyboard");
            uploadProgressBar.setIndeterminate(true);

            // Send erase sysex command;
            byte[] msg = {4,-16,0,32,7,109,9,-9,0};
            testDevice.write(msg, msg.length);

            try{
                Thread.sleep(4000);
            }
            catch(InterruptedException e){
                return null;
            }

            response = testDevice.readResponse();
            response.parseResponseData();

            if(response.getReply() != 5){
                progressLabel.setText("Erase failed - try again");
                return null;
            }
            progressLabel.setText("Erase complete");
            uploadProgressBar.setIndeterminate(false);

            try{
                Thread.sleep(500);
            }
            catch(InterruptedException e){
                return null;
            }

            /** Program part

              * Start loop to send program memory.
              * Add progress bar, and success message.
              * Rather than add additional chars to array, simply send the
              * Relevant extra chars within a state machine.
            */
            progressLabel.setText("Programming");
            /** Send header and preamble stuff to start off programming */
            byte[] msgStart = {4,-16,0,32,4,109,10};

            /** Need to precompile the midi codes into the message. */
            int inIndex = 0;
            int outIndex = 0;
            byte marker = 0;
            int percentDone = 0;
            int currentPercentDone = 0;
            
            setProgress(0);

            uploadBinary = new byte[64];
            uploadBinary[0] = msgStart[0];
            uploadBinary[1] = msgStart[1];
            uploadBinary[2] = msgStart[2];
            uploadBinary[3] = msgStart[3];
            uploadBinary[4] = msgStart[4];
            uploadBinary[5] = msgStart[5];
            uploadBinary[6] = msgStart[6];
            outIndex = 7;

            for( inIndex = 0; inIndex < uploadFile.length; inIndex++ ){

                /** Check to see if we need to put a midi header marker in here
                 * to denote the end of the sysex message.
                 */
                if ( ( ( inIndex - 1 ) % 3 ) == 0 ){

                     switch(uploadFile.length - inIndex){
                         case 0:
                             marker = 5;
                             break;
                         case 1:
                             marker = 6;
                             break;
                         case 2:
                             marker = 7;
                             break;
                         default:
                             marker = 4;
                             break;
                     }
                     uploadBinary[outIndex] = marker;
                     outIndex++;
                 }

                 if( outIndex > 63 ){
                     testDevice.write(uploadBinary, uploadBinary.length);
                     outIndex = 0;
                 }

                 uploadBinary[outIndex] = uploadFile[inIndex];
                 outIndex++;

                 if( outIndex > 63 ){
                     testDevice.write(uploadBinary, uploadBinary.length);
                     outIndex = 0;
                 }
                 percentDone = (int)(( (float)inIndex / (float)uploadFile.length )*100.0);
                 if( percentDone > currentPercentDone + 10 ){
                     setProgress(percentDone);
                     currentPercentDone = percentDone;
                 }
            }

            if(outIndex != 0){

                uploadBinary[outIndex]=-9;
                outIndex++;

                while( outIndex < 64 ){
                     uploadBinary[outIndex]=0;
                     outIndex++;
                }
                // Send the remainder
                testDevice.write(uploadBinary, outIndex);
                setProgress(100);
            }
            /** If ack recieved then set mode to app enabled
             * and return success. Else show error dialog to retry.
             * return error value.
             * */
            int noOfTries = 0;
            int reply = testDevice.readResponse().getReply();

            while( ( reply != 5) && (reply != 4) && (noOfTries < 25) ){
               reply = testDevice.readResponse().getReply();
               noOfTries++;
            }

            if( ( noOfTries < 25 ) && ( reply == 5 ) ){
                testDevice.closeUsbDevice();
                noOfTries = 0;
                progressLabel.setText("Programming Done");
                messageDialogBox.showMessageDialog(uploaderUI.this, "Programming Success");
                /** Re-establish USB comms with the reset keyboard */
                progressLabel.setText("Resetting Keyboard");
                uploaderUI.this.scanForKeyboards();
                setTestDevice(selectedDevice);
                /** Set mode to enabled */
                setMode(2);
            }
            else{
               progressLabel.setText("Programming Failed - retry");
               setProgress(0);
               return null;
            }
            progressLabel.setText("Keyboard reset");
            try{
                Thread.sleep(1000);
            }
            catch(InterruptedException e){
                setProgress(0);
                return null;
            }
            progressLabel.setText("Update Complete");
            setProgress(0);
            return null;
        }

        /**
         * Executed in event dispatching thread
         */
        @Override
        public void done() {
            uploadButton.setEnabled(true);
            setCursor(null); //turn off the wait cursor
        }
    }

   private int programTarget(){

       /** Check that both the target is selected and the code has
        * been loaded into the buffer before starting to program.
        * If upload code is null then popup an error dialog, and
        * return an error code.
        * */

       /** If target is none flag an error dialog, and return an error
        * code.
        * */
       if( deviceComboBox.getSelectedIndex() == 0 ){
           messageDialogBox.showMessageDialog(this, "Select View-> Refresh\n and choose keyboard");
           return -1;
       }

       if( getUploadResource() != 0){
           messageDialogBox.showMessageDialog(this, "Update code not available");
           return -1;
       }

       if( uploadFile == null ){
           messageDialogBox.showMessageDialog(this, "Update code not available");
           return -1;
       }

       /** Request operating mode (00).
        * If not bootstrap mode then set it.
        * */
       if( getMode() != 0 ){
           if(setMode(4) != 0){
               messageDialogBox.showMessageDialog(this, "Cannot set bootload mode");
               return -1;
           }
       }
       int confirm = messageDialogBox.showConfirmDialog(this,
                                                    "Updating to version " + codeVersion + "\nAre you sure?" ,
                                                    "Update Confirmation",
                                                    JOptionPane.YES_NO_OPTION);

       if(confirm == JOptionPane.NO_OPTION){
           progressLabel.setText("Update cancelled");
           return -1;
       }
       
       
        /** Setup progress bar for upload. */
        uploadProgressBar.setMaximum(100);
        uploadProgressBar.setMinimum(0);
        /** Disablee program key */
        uploadButton.setEnabled(false);
        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

        /** Start upload task and leave UI running to update progress bar. */
        uploadTask = new UploadTask();
        uploadTask.addPropertyChangeListener(this);
        uploadTask.execute();
        return 0;
   }

   private int getUploadResource(){

        try{
            int fileLength = 0;
            int bufferOffset = 0;
            byte[] incommingStream = new byte[512 * 1024];

            InputStream uploadFileStream = this.getClass().getResourceAsStream("resources/App110.hex");

            while( fileLength != -1 ){

                fileLength = uploadFileStream.read(incommingStream,bufferOffset,8192);
                bufferOffset = bufferOffset + fileLength;
            }
            uploadFileStream.close();

            uploadFile = new byte[bufferOffset+1];

            for(int index=0;index< (bufferOffset+1);index++){
                uploadFile[index]=incommingStream[index];
            }
            if(DEBUG){
                // Add code to display are you sure box.
                System.out.println("First element of resource = " + uploadFile[0]);
                System.out.println("Last element of resource = " + uploadFile[uploadFile.length-1]);
                System.out.println("Size of resource = " + uploadFile.length);
            }
        }
        catch(FileNotFoundException e){
            System.out.println("File not found");
            return -1;
        }
        catch(IOException e){
            System.out.println("IOException thrown");
            return -2;
        }
        return 0;
   }

   private void scanForKeyboards(){
        
        int i = 1; /** Index 0 reserved for None option. */
        String serialNumber = "";

        LibusbJava.usb_init();
	LibusbJava.usb_find_busses();
	LibusbJava.usb_find_devices();
	Usb_Bus bus = LibusbJava.usb_get_busses();

        Usb_Device currentDevice = null;
        currentDevice = bus.getDevices();

        /** Create an array of usb devices which match the target
         * vendor id, and populate the combobox.
         * */
        deviceComboBox.removeAllItems();
        /** Add none as an option. */
        deviceComboBox.addItem("None");

        while( currentDevice != null ){
           if(currentDevice.getDescriptor().getIdVendor() == 0x1d17 ){
              foundDevices[i] = currentDevice;
              setTestDevice(i);
              /** Make call to get serial number in here. */
              serialNumber = getSerialNumber(i);
              testDevice.closeUsbDevice();
              testDevice = null;
              i++;
              deviceComboBox.addItem(serialNumber);
           }
           currentDevice = currentDevice.getNext();
        }
        setTestDevice(0);
    }


   private void setTestDevice(int index){

        testDevice = new TestDevice();

        Usb_Config_Descriptor[] config = null;
        Usb_Interface[] USBinterface = null;
        Usb_Interface_Descriptor[] altSetting = null;
        Usb_Endpoint_Descriptor[] endpoints = null;

        Usb_Endpoint_Descriptor[] outEPs = null;
        Usb_Endpoint_Descriptor[] inEPs = null;

        int nofOutEPs = 0;
        int nofInEPs = 0;

	int altinterface = -1;
	int interface_ = -1;
        int configuration = -1;
	short vendorId = -1;
	short productId = -1;
        String filename = null;
        String busName = null;


        if( index != 0 ){

            if(testDevice != null){
               testDevice.closeUsbDevice();
            }
            
            config = foundDevices[index].getConfig();
            vendorId = foundDevices[index].getDescriptor().getIdVendor();
            productId = foundDevices[index].getDescriptor().getIdProduct();
            filename = foundDevices[index].getFilename();
            busName = foundDevices[index].getBus().getDirname();

            if( config != null ){
               configuration = config[0].getBConfigurationValue();
               USBinterface = config[0].getInterface();
               if (USBinterface != null){
                  altSetting = USBinterface[0].getAltsetting();
                  if (altSetting != null){
                     interface_ = altSetting[0].getBInterfaceNumber();
                     altinterface = altSetting[0].getBAlternateSetting();
                     endpoints = altSetting[0].getEndpoint();
                  }
               }
            }

            /** Check endpoint addresses for IN or OUT access */
            if (endpoints != null) {
                outEPs = new Usb_Endpoint_Descriptor[endpoints.length];
                inEPs = new Usb_Endpoint_Descriptor[endpoints.length];
                for (int i = 0; i < endpoints.length; i++) {
                    int epAddr = endpoints[i].getBEndpointAddress() & 0xFF;
                    if ((epAddr & 0x80) > 0) {
                        // is IN endpoint
                        inEPs[nofInEPs++] = endpoints[i];
                    } else {
                        // is OUT endpoint
                        outEPs[nofOutEPs++] = endpoints[i];
                    }
                }
            }

            testDevice.setIdProduct(productId);
            testDevice.setIdVendor(vendorId);
            testDevice.setAltinterface(altinterface);
            testDevice.setConfiguration(configuration);
            testDevice.setInterface(interface_);
            // Add setting for bus and filename.
            testDevice.setFilename(filename);
            testDevice.setBusName(busName);

            if (inEPs != null) {
                for (int i = 0; i < nofInEPs; i++) {
                    int type = inEPs[i].getBmAttributes() & 0x03;
                    switch (type) {
                    case Usb_Endpoint_Descriptor.USB_ENDPOINT_TYPE_BULK:
                        testDevice.setInEPBulk(inEPs[i]
                                .getBEndpointAddress() & 0xff);
                        testDevice.setInMode(TransferMode.Bulk);
                        break;
                    case Usb_Endpoint_Descriptor.USB_ENDPOINT_TYPE_INTERRUPT:
                        testDevice.setInEPInt(inEPs[i]
                                .getBEndpointAddress() & 0xff);
                        testDevice.setInMode(TransferMode.Interrupt);
                        break;
                    default:
                        break;
                    }
                }
            }
            if (outEPs != null) {
                for (int i = 0; i < nofOutEPs; i++) {
                    int type = outEPs[i].getBmAttributes() & 0x03;
                    switch (type) {
                    case Usb_Endpoint_Descriptor.USB_ENDPOINT_TYPE_BULK:
                        testDevice.setOutEPBulk(outEPs[i]
                                .getBEndpointAddress() & 0xff);
                        testDevice.setOutMode(TransferMode.Bulk);
                        break;
                    case Usb_Endpoint_Descriptor.USB_ENDPOINT_TYPE_INTERRUPT:
                        testDevice.setOutEPInt(outEPs[i]
                                .getBEndpointAddress() & 0xff);
                        testDevice.setOutMode(TransferMode.Interrupt);
                        break;
                    default:
                        break;
                    }
                }
            }
            testDevice.openUsbDevice();
            pingDevice();
            selectedDevice = index;
        }
    }


   private int getMode(){
        TestDeviceResponse response = new TestDeviceResponse();
        int mode = 0;
        byte[] payload = null;
        /** Send mode query sysex command */
        byte[] msg = {4,-16,0,32,7,109,8,-9,0};
        testDevice.write(msg, msg.length);

        response = testDevice.readResponse();
        response.parseResponseData();

        if(response.getReply() == 1){
            payload = response.getResponsePayload();
        }
        return (int)payload[5];
   }

   private int setMode(int mode){

        TestDeviceResponse response = new TestDeviceResponse();

        /** Set bootmode sysex command */
        byte[] msg = {4,-16,0,32,7,109,2,-9,0};

        msg[6] = (byte)mode;

        testDevice.write(msg, msg.length);

        response = testDevice.readResponse();
        response.parseResponseData();

        if(response.getReply() == 5){
            return 0;
        }
        else return -1;
   }

   private void pingDevice(){
        /** Send mode query sysex command */
        byte[] msg = {4,-16,0,32,7,109,8,-9,0};
        testDevice.write(msg, msg.length);
        testDevice.readResponse();
   }
   
   private String getSerialNumber(int i){

       /** The usb device should already be open by this point,
        *  But need to add checking
        */
       TestDeviceResponse response = new TestDeviceResponse();
       String resultString;
       int lengthOfSerialNumber = 13;
       byte[] serialNumber = new byte[64];

       /** Send a sysex command to request serial number */
       byte[] msg = {4,-16,0,32,7,109,7,-9,0};
       testDevice.write(msg, msg.length);

       /** Get a response */
       response = testDevice.readResponse();

       int reply = response.getReply();

       /** If response is nak then no serial number is available */
       if( reply == 4 ){
           resultString = "No S/N in dev";
       }
       else if( ( reply < 1) || (reply > 5)){
           resultString = "Err in read";
       }
       else{
          /** Call routine to extract payload */
          response.parseResponseData();
          /** Copy payload into char array */
          serialNumber = response.getResponsePayload();
          /** Set the result string to the serial number */
          resultString = new String(serialNumber,5,lengthOfSerialNumber);
       }   
       return resultString;
   }
}